import type { PlayerType } from "isaac-typescript-definitions";
import type { ConversionHeartSubType } from "../../../types/ConversionHeartSubType";
import { Feature } from "../../private/Feature";
export declare class CharacterHealthConversion extends Feature {
    private readonly characterHealthReplacementMap;
    private readonly prePickupCollisionHeart;
    private readonly postPEffectUpdateReordered;
    /**
     * Helper function to make a character that has the same health mechanic as Blue Baby (red heart
     * containers --> soul hearts) or Dark Judas (red heart containers --> black hearts).
     *
     * Call this function once at the beginning of your mod to declare the health conversion type.
     *
     * In order to use this function, you must upgrade your mod with
     * `ISCFeature.CHARACTER_HEALTH_CONVERSION`.
     */
    registerCharacterHealthConversion(playerType: PlayerType, conversionHeartSubType: ConversionHeartSubType): void;
}
//# sourceMappingURL=CharacterHealthConversion.d.ts.map