import { Feature } from "../../private/Feature";
export declare class FadeInRemover extends Feature {
    private enabled;
    private readonly postGameStartedReordered;
    /**
     * Removes the fade-in that occurs at the beginning of a run. If this behavior is desired, call
     * this function once at the beginning of your mod.
     *
     * This is useful for debugging, when you are resetting the game often.
     *
     * You can restore the vanilla behavior with the `restoreFadeIn` function.
     *
     * In order to use this function, you must upgrade your mod with `ISCFeature.FADE_IN_REMOVER`.
     */
    removeFadeIn(): void;
    /**
     * Disables the fade-in remover. Only useful if you have previously called the `removeFadeIn`
     * function.
     *
     * In order to use this function, you must upgrade your mod with `ISCFeature.FADE_IN_REMOVER`.
     */
    restoreFadeIn(): void;
}
//# sourceMappingURL=FadeInRemover.d.ts.map