import { CollectibleType } from "isaac-typescript-definitions";
import { Feature } from "../../private/Feature";
export declare class PreventCollectibleRotation extends Feature {
    private readonly pickupIndexCreation;
    private readonly runInNFrames;
    private readonly preUseItem;
    /**
     * Soul of Isaac causes items to flip. We assume that the player deliberately wants to roll a
     * quest item, so we delete all tracked items in the current room.
     */
    private readonly postUseCardSoulOfIsaac;
    private readonly postDiceRoomActivated;
    private readonly postPickupChanged;
    /**
     * Helper function to prevent a collectible from being affected by Tainted Isaac's rotation
     * mechanic. (This mechanic also happens from Glitched Crown and Binge Eater.) This is useful
     * because quest items that are manually spawned by mods will be automatically be affected by this
     * mechanic.
     *
     * It is required to pass the intended collectible type to this function since it is possible for
     * collectibles to rotate on the first frame that they are spawned.
     *
     * In order to use this function, you must upgrade your mod with
     * `ISCFeature.PREVENT_COLLECTIBLE_ROTATION`.
     */
    preventCollectibleRotation(collectible: EntityPickup, collectibleType: CollectibleType): void;
}
//# sourceMappingURL=PreventCollectibleRotation.d.ts.map