/**
 * The IsaacScript standard library contains many optional features, such as the ability to create
 * custom pickups. All features are optional and are only initialized when needed. This class
 * contains elements to facilitate that.
 *
 * Additionally, all custom callbacks extend from this class.
 */
export declare abstract class Feature {
    /**
     * All features should only be instantiated once and are passed around to other features using
     * dependency injection. We provide a run-time check in order to prevent the bug of any feature
     * accidentally being instantiated twice.
     */
    private static readonly constructedClassNames;
    constructor();
}
//# sourceMappingURL=Feature.d.ts.map