/// <reference types="isaac-typescript-definitions" />
export declare function getElapsedGameFramesSince(gameFrameCount: int): int;
export declare function getElapsedRenderFramesSince(renderFrameCount: int): int;
export declare function getElapsedRoomFramesSince(roomFrameCount: int): int;
/**
 * Helper function to check if the current game frame count is higher than a specific game frame
 * count.
 */
export declare function isAfterGameFrame(gameFrameCount: int): boolean;
/**
 * Helper function to check if the current render frame count is higher than a specific render frame
 * count.
 */
export declare function isAfterRenderFrame(renderFrameCount: int): boolean;
/**
 * Helper function to check if the current room frame count is higher than a specific room frame
 * count.
 */
export declare function isAfterRoomFrame(roomFrameCount: int): boolean;
/**
 * Helper function to check if the current game frame count is lower than a specific game frame
 * count.
 */
export declare function isBeforeGameFrame(gameFrameCount: int): boolean;
/**
 * Helper function to check if the current render frame count is lower than a specific render frame
 * count.
 */
export declare function isBeforeRenderFrame(renderFrameCount: int): boolean;
/**
 * Helper function to check if the current room frame count is lower than a specific room frame
 * count.
 */
export declare function isBeforeRoomFrame(roomFrameCount: int): boolean;
/**
 * Helper function to check if the current game frame count is exactly equal to a specific game
 * frame count.
 *
 * This returns false if the submitted render frame count is null or undefined.
 */
export declare function onGameFrame(gameFrameCount: int | null | undefined): boolean;
/**
 * Helper function to check if the current game frame count is equal to or higher than a specific
 * game frame count.
 */
export declare function onOrAfterGameFrame(gameFrameCount: int): boolean;
/**
 * Helper function to check if the current render frame count is equal to or higher than a specific
 * render frame count.
 */
export declare function onOrAfterRenderFrame(renderFrameCount: int): boolean;
/**
 * Helper function to check if the current room frame count is equal to or higher than a specific
 * room frame count.
 */
export declare function onOrAfterRoomFrame(roomFrameCount: int): boolean;
/**
 * Helper function to check if the current game frame count is equal to or lower than a specific
 * game frame count.
 */
export declare function onOrBeforeGameFrame(gameFrameCount: int): boolean;
/**
 * Helper function to check if the current render frame count is equal to or lower than a specific
 * render frame count.
 */
export declare function onOrBeforeRenderFrame(renderFrameCount: int): boolean;
/**
 * Helper function to check if the current room frame count is equal to or lower than a specific
 * room frame count.
 */
export declare function onOrBeforeRoomFrame(roomFrameCount: int): boolean;
/**
 * Helper function to check if the current render frame count is exactly equal to a specific render
 * frame count.
 *
 * This returns false if the submitted render frame count is null or undefined.
 */
export declare function onRenderFrame(renderFrameCount: int | null | undefined): boolean;
/**
 * Helper function to check if the current room frame count is exactly equal to a specific room
 * frame count.
 *
 * This returns false if the submitted room frame count is null or undefined.
 */
export declare function onRoomFrame(roomFrameCount: int | null | undefined): boolean;
//# sourceMappingURL=frames.d.ts.map