import type { CollectibleType, TrinketType } from "isaac-typescript-definitions";
import { ItemPoolType } from "isaac-typescript-definitions";
/**
 * Helper function to get a random item pool. This is not as simple as getting a random value from
 * the `ItemPoolType` enum, since `ItemPoolType.SHELL_GAME` (7) is not a real item pool and the
 * Greed Mode item pools should be excluded if not playing in Greed Mode.
 */
export declare function getRandomItemPool(): ItemPoolType;
/**
 * Helper function to remove one or more collectibles from all item pools.
 *
 * This function is variadic, meaning you can pass as many collectible types as you want to remove.
 */
export declare function removeCollectibleFromPools(...collectibleTypes: CollectibleType[]): void;
/**
 * Helper function to remove one or more trinkets from all item pools.
 *
 * This function is variadic, meaning you can pass as many trinket types as you want to remove.
 */
export declare function removeTrinketFromPools(...trinketTypes: TrinketType[]): void;
//# sourceMappingURL=itemPool.d.ts.map