import type { CollectibleType } from "isaac-typescript-definitions";
import { PlayerForm } from "isaac-typescript-definitions";
/** Returns a set of the player's current transformations. */
export declare function getPlayerTransformations(player: EntityPlayer): Set<PlayerForm>;
/**
 * Helper function to get a transformation name from a PlayerForm enum.
 *
 * For example:
 *
 * ```ts
 * const transformationName = getTransformationName(PlayerForm.LORD_OF_THE_FLIES);
 * // transformationName is "Beelzebub"
 * ```
 */
export declare function getTransformationName(playerForm: PlayerForm): string;
/**
 * Returns a set containing all of the transformations that the given collectible types contribute
 * towards.
 */
export declare function getTransformationsForCollectibleType(collectibleType: CollectibleType): Set<PlayerForm>;
export declare function hasFlyingTransformation(player: EntityPlayer): boolean;
export declare function isTransformationFlying(playerForm: PlayerForm): boolean;
//# sourceMappingURL=transformations.d.ts.map