import type { BossID, PlayerType } from "isaac-typescript-definitions";
/**
 * Helper function to get the path to the name file that corresponds to the graphic shown on the
 * versus screen for the particular boss.
 *
 * For example, the file path for `BossID.MONSTRO` is "gfx/ui/boss/bossname_20.0_monstro.png".
 */
export declare function getBossNamePNGFilePath(bossID: BossID): string;
/**
 * Helper function to get the path to the portrait file that corresponds to the graphic shown on the
 * versus screen for the particular boss.
 *
 * For example, the file path for `BossID.MONSTRO` is "gfx/ui/boss/portrait_20.0_monstro.png".
 */
export declare function getBossPortraitPNGFilePath(bossID: BossID): string;
/**
 * Helper function to get the path to the name file that corresponds to the graphic shown on the
 * versus screen for the particular character.
 *
 * For example, the file path for `PlayerType.ISAAC` is "gfx/ui/boss/playername_01_isaac.png".
 */
export declare function getCharacterNamePNGFilePath(character: PlayerType): string;
/**
 * Helper function to get the path to the portrait file that corresponds to the graphic shown on the
 * versus screen for the particular character.
 *
 * For example, the file path for `PlayerType.ISAAC` is "gfx/ui/boss/playerportrait_isaac.png".
 */
export declare function getCharacterPortraitPNGFilePath(character: PlayerType): string;
//# sourceMappingURL=versusScreen.d.ts.map